<script lang="ts">
  import {
    canPickTile,
    createActionDispatcher,
    getCellColor,
    getColor,
    getFloor as getPenaltyRow,
    getGroup,
    isActive,
    isDonePlacingTiles,
    isFilled,
  } from "../util";
  import EmptyTile from "./EmptyTile.svelte";
  import TileC from "./Tile.svelte";
  import Score from "./Score.svelte";

  const dispatchAction = createActionDispatcher();

  export let user: Player | null;

  export let state: GameState;
  export let player: Player;

  $: userIsPicking =
    state.phase[0] === "Picking" && user !== null && isActive(state, user.id);

  export let selectedTile: ColoredTile | null;

  let selectedRow: number | null = null;
</script>

<div>
  <gs6-player-box userid={player.id} active={isActive(state, player.id)} />

  {#if player.id === user?.id && userIsPicking}
    <div class="picking-action">
      <div>
        {#if selectedTile === null}
          <div>↖ <em>Select tiles.</em></div>
        {/if}
        <button
          class="primary"
          disabled={selectedTile === null ||
            selectedRow === null ||
            !canPickTile(player, selectedTile, selectedRow)}
          on:click={() => {
            if (selectedTile !== null && selectedRow !== null) {
              dispatchAction([
                "Pick",
                { tile: selectedTile, row: selectedRow },
              ]);
              selectedTile = null;
              selectedRow = null;
            }
          }}
        >
          Pick tiles
        </button>

        {#if selectedRow === null}
          <div>↙ <em>Select row.</em></div>
        {:else if selectedTile !== null && selectedRow !== null && !canPickTile(player, selectedTile, selectedRow)}
          <div><em>Tile can't be placed in this row.</em></div>
        {/if}
      </div>
    </div>
  {/if}

  <div
    class="player-board panel border shadow"
    class:user={player.id === user?.id}
  >
    <div class="player-score">
      <Score score={player.score} />
    </div>
    <div class="patterns">
      {#each player.patterns as row, rowIdx (rowIdx)}
        <label class="pattern-row" for="select-row-{rowIdx}">
          <div
            class="pattern-row-tiles"
            class:selected={player.id === user?.id &&
              userIsPicking &&
              rowIdx === selectedRow}
          >
            {#if player.id === user?.id && userIsPicking}
              <input
                type="radio"
                name="select-picking-row"
                id="select-row-{rowIdx}"
                value={rowIdx}
                bind:group={selectedRow}
              />
            {/if}
            {#each Array(rowIdx + 1) as _, tileIdx (tileIdx)}
              <div class="pattern-tile">
                <EmptyTile>
                  {#if row[tileIdx] !== undefined}
                    <TileC tile={row[tileIdx]} />
                  {/if}
                </EmptyTile>
              </div>
            {/each}
          </div>
        </label>
      {/each}
    </div>

    <div class="wall">
      {#each player.wall as row, rowIdx}
        <div class="wall-row">
          {#each row as cell, columnIdx}
            <div class="wall-tile">
              <EmptyTile color={getCellColor(cell)}>
                {@const filled = isFilled(cell)}
                {@const buttonDisabled =
                  filled ||
                  state.phase[0] !== "Tiling" ||
                  player.id !== user?.id ||
                  !isActive(state, user?.id) ||
                  player.patterns.findIndex(
                    (patternRow, idx) => patternRow.length === idx + 1
                  ) !== rowIdx ||
                  getColor(player.patterns[rowIdx][0]) !==
                    getCellColor(player.wall[rowIdx][columnIdx])}

                {#if filled}
                  <TileC tile={cell} />
                {:else}
                  <button
                    class="wall-tile-button"
                    disabled={buttonDisabled}
                    on:click={() =>
                      dispatchAction([
                        "Place",
                        { row: rowIdx, column: columnIdx },
                      ])}
                  />
                {/if}
              </EmptyTile>
            </div>
          {/each}
        </div>
      {/each}
    </div>

    <label class="floor" for="select-row-floor">
      <div
        class="floor-tiles"
        class:selected={player.id === user?.id &&
          userIsPicking &&
          selectedRow === 5}
      >
        {#if player.id === user?.id && userIsPicking}
          <input
            type="radio"
            name="select-picking-row"
            id="select-row-floor"
            value={5}
            bind:group={selectedRow}
          />
        {/if}
        {#each getPenaltyRow(player) as tile, tileIdx (tileIdx)}
          <div class="floor-tile">
            <EmptyTile penalty={tileIdx < 2 ? -1 : tileIdx < 5 ? -2 : -3}>
              {#if tile !== null}
                <TileC {tile} />
              {/if}
            </EmptyTile>
          </div>
        {/each}
      </div>
    </label>

    {#if state.phase[0] === "Tiling" && user !== null && user.id === player.id && isActive(state, user.id) && isDonePlacingTiles(user)}
      <div class="floor">
        <button
          class="primary small"
          on:click={() => dispatchAction(["Sweep"])}
        >
          Resolve penalty
        </button>
      </div>
    {/if}
  </div>
</div>

<style>
  .player-score {
    position: absolute;
    font-size: 2em;
    left: 0.3em;
    top: 0.3em;
    transform: translate(-50%, -50%);
  }

  .picking-action {
    white-space: nowrap;
    position: absolute;
    bottom: 0;
    left: calc(100% + 1rem);
    transform: translateY(-2.5rem);
  }

  .picking-action > div {
    position: relative;
  }

  .picking-action > div > div:first-child {
    position: absolute;
    bottom: calc(100% + 0.125rem);
  }

  .picking-action > div > div:last-child {
    position: absolute;
    top: calc(100% + 0.125rem);
  }

  .picking-action em {
    font-weight: 300;
  }

  .player-board {
    position: absolute;
    bottom: 0.5rem;
    left: 50%;
    transform: translate(-50%, 100%);

    background-color: var(--board-background-color);
    border-color: var(--board-border-color);

    display: grid;
    column-gap: 1em;
    row-gap: 0.5em;

    place-content: center;
    grid-template-columns: 1fr 1fr;
  }

  .player-board:not(.user) {
    font-size: 0.67em;
  }
  .floor {
    grid-column-start: 1;
    grid-column-end: 3;
    display: flex;
    flex-wrap: nowrap;
    justify-content: center;
    align-items: center;
  }

  .floor-tiles {
    display: flex;
    position: relative;
  }
  .floor-tiles.selected {
    outline: 3px solid #0085ff;
    border-radius: 0.2em;
  }

  .floor input {
    margin: 0;

    position: absolute;
    left: 0;
    top: 50%;
    transform: translate(-100%, -50%) translateX(-0.15em);
  }

  .floor-tile,
  .wall-tile,
  .pattern-tile {
    margin: 0.125em;
  }

  .pattern-row {
    display: flex;
    flex-wrap: nowrap;
    justify-content: center;
  }

  .pattern-row .selected {
    outline: 3px solid #0085ff;
    border-radius: 0.2em;
  }
  .pattern-row-tiles {
    position: relative;
    display: flex;
  }

  .pattern-row input {
    margin: 0;

    position: absolute;
    left: 0;
    top: 50%;
    transform: translate(-100%, -50%) translateX(-0.15em);
  }

  .wall-row {
    display: flex;
    flex-wrap: nowrap;
  }

  .wall-tile-button {
    position: absolute;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    height: 100%;
    width: 100%;
    margin: 0;
    padding: 0;
    border: 0;
    font-size: inherit;
    display: block;
    background: inherit;
  }
  .wall-tile-button:not(:disabled) {
    cursor: pointer;
  }

  @keyframes pulsein {
    from {
      transform: scale(1.35);
      filter: opacity(50%);
    }

    to {
      transform: scale(1.2);
      filter: opacity(100%);
    }
  }

  .wall-tile-button:not(:disabled)::after {
    content: "";
    outline: #0085ff 0.15em solid;
    border-radius: 0.1em;
    width: 100%;
    height: 100%;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    display: block;
    transform: scale(1.25);
    animation: 0.5s pulsein alternate infinite;
  }
</style>
